-- by modelleicher
-- 30/05/2018
-- https://www.facebook.com/Modelleicher/

-- 21.11.2018 conversion to FS19
-- 02.12.2018 fixed Inputs for FS19
-- 08.12.2018 fixed bugs with growth when timescale is actually 0, its 0.0001 instead now for 0
-- 14.04.2019 max. timescale changed from 240 to 480, made ready for modhub release 

-- 12.04.2025 converted to FS25 since nobody else has published a Mod to stop time yet, adjusted max timescale to 1000 and changed below 1 to 0.2 steps
-- 29.06.2025 reduced max timescale to 500 at request of modhub testing


fineTimescaleAdjustment = {};
addModEventListener(fineTimescaleAdjustment);

function fineTimescaleAdjustment:loadMap(name)
	self.lastTimeScale = g_currentMission.missionInfo.timeScale;
	
	self.inputsActive = false;
end;

function fineTimescaleAdjustment:INCREASE_TIMESCALE_MOD()
	local scale = g_currentMission.missionInfo.timeScale
	
	if scale < 1 then
		scale = self.lastTimeScale + 0.2;
	elseif scale < 15 then
		scale = self.lastTimeScale + 1;
	elseif scale < 30 then
		scale = self.lastTimeScale + 5;
	elseif scale < 60 then
		scale = self.lastTimeScale + 10;
	elseif scale < 240 then
		scale = self.lastTimeScale + 20;
	elseif scale < 400 then
		scale = self.lastTimeScale + 40;
	else	
		scale = self.lastTimeScale + 100;
	end;
	
	scale = math.min(scale, 500)

	g_currentMission:setTimeScale(scale)
	
	self.lastTimeScale = scale;

end;

function fineTimescaleAdjustment:DECREASE_TIMESCALE_MOD()
	local scale = g_currentMission.missionInfo.timeScale
		
	if scale < 2 then
		scale = self.lastTimeScale - 0.2;		
	elseif scale < 15 then
		scale = self.lastTimeScale - 1;
	elseif scale < 30 then
		scale = self.lastTimeScale - 5;
	elseif scale < 60 then
		scale = self.lastTimeScale - 10;
	elseif scale < 240 then
		scale = self.lastTimeScale - 20;
	elseif scale < 400 then
		scale = self.lastTimeScale - 40;
	else	
		scale = self.lastTimeScale - 100;
	end;
	
	scale = math.max(scale, 0.0001)

	g_currentMission:setTimeScale(scale)
	
	self.lastTimeScale = scale;

end;


function fineTimescaleAdjustment:update(dt)
	-- Input Action Events in FS19. Apparantly you have to add them only for the duration you want them to work
	-- If I get into a vehicle of any sort it automatically resets the list. So I don't need to clear them?
	-- just add them each time you leave a vehicle basically. (g_currentMission.controlledVehicle is nil again)
	if g_currentMission:getIsClient() then -- don't run on the Dedicated Server itself
		if g_gui.currentGui == nil and g_currentMission.controlledVehicle == nil then -- only if no vehicle is entered or menu is up
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then -- only if we are the host or logged in as admin
				if not self.inputsActive then
					
					local _, actionEventId = g_inputBinding:registerActionEvent('INCREASE_TIMESCALE_MOD', self, fineTimescaleAdjustment.INCREASE_TIMESCALE_MOD, false, true, false, true)							
					local _, actionEventId = g_inputBinding:registerActionEvent('DECREASE_TIMESCALE_MOD', self, fineTimescaleAdjustment.DECREASE_TIMESCALE_MOD, false, true, false, true)
					
				end;
			end;
		else
			self.inputsActive = false;
		end;
	end;
	
end

